###############################################################################
# Copyright (c) 2009, 2011, Oracle and/or its affiliates. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice (including the next
# paragraph) shall be included in all copies or substantial portions of the
# Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.
#

diff --git a/nls/iso8859-1/Compose.pre b/nls/iso8859-1/Compose.pre
index c726ecf..da43183 100644
--- a/nls/iso8859-1/Compose.pre
+++ b/nls/iso8859-1/Compose.pre
@@ -11,6 +11,7 @@ XCOMM Special Character
 <Multi_key> <apostrophe> <space>	: "'"	apostrophe
 <Multi_key> <space> <apostrophe>	: "'"	apostrophe
 <Multi_key> <A> <T>			: "@"	at
+<Multi_key> <A> <A>			: "@"	at
 <Multi_key> <parenleft> <parenleft>	: "["	bracketleft
 <Multi_key> <slash> <slash>		: "\\"	backslash
 <Multi_key> <slash> <less>		: "\\"	backslash
@@ -193,7 +194,8 @@ XCOMM Accented Alphabet
 <Multi_key> <diaeresis> <A>		: "\304"	Adiaeresis
 <Multi_key> <A> <asterisk>		: "\305"	Aring
 <Multi_key> <asterisk> <A>		: "\305"	Aring
-<Multi_key> <A> <A>			: "\305"	Aring
+XCOMM Conflicts with <A> <A> -> "@" above
+XCOMM <Multi_key> <A> <A>			: "\305"	Aring
 <Multi_key> <A> <O>			: "\305"	Aring
 <Multi_key> <A> <E>			: "\306"	AE
 <Multi_key> <a> <grave>			: "\340"	agrave
@@ -394,7 +396,7 @@ XCOMM Special Character
 XCOMM These are for us_intl, that does not have diaeresis, etc
 <dead_acute> <space>			: "'"	apostrophe
 <dead_acute> <dead_acute>		: "\264"	acute
-<dead_diaeresis> <space>		: "\""	quotedbl
+<dead_diaeresis> <space>		: "\250"	diaeresis
 <dead_diaeresis> <dead_diaeresis>	: "\250"	diaeresis
 <dead_doubleacute> <space>		: "\""	quotedbl
 <dead_abovering> <space>		: "\260"	degree
@@ -471,7 +473,6 @@ XCOMM Useful for portuguese language
 <dead_acute> <C>			: "\307"	Ccedilla
 <dead_acute> <c>			: "\347"	ccedilla
 XCOMM
-#ifdef USE_CTRL_SHIFT_T_SEQS
 XCOMM Ctrl<T> Means <Compose>
 XCOMM Special Character
 Ctrl<T> <plus> <plus>			: "#"	numbersign
@@ -658,7 +659,6 @@ Ctrl<T> <A> <diaeresis>			: "\304"	Adiaeresis
 Ctrl<T> <diaeresis> <A>			: "\304"	Adiaeresis
 Ctrl<T> <A> <asterisk>			: "\305"	Aring
 Ctrl<T> <asterisk> <A>			: "\305"	Aring
-Ctrl<T> <A> <A>				: "\305"	Aring
 Ctrl<T> <A> <O>				: "\305"	Aring
 Ctrl<T> <A> <E>				: "\306"	AE
 Ctrl<T> <a> <grave>			: "\340"	agrave
@@ -839,5 +839,70 @@ Ctrl<T> <y> <quotedbl>			: "\377"	ydiaeresis
 Ctrl<T> <quotedbl> <y>			: "\377"	ydiaeresis
 Ctrl<T> <y> <diaeresis>			: "\377"	ydiaeresis
 Ctrl<T> <diaeresis> <y>			: "\377"	ydiaeresis
-#endif /* USE_CTRL_SHIFT_T_SEQS */
 XCOMM End of Sequence Definition
+XCOMM Corrected dead key accent keysyms for Danish
+<SunFA_Acute> <A>			: "\301"	Aacute
+<SunFA_Acute> <E>			: "\311"	Eacute
+<SunFA_Acute> <I>			: "\315"	Iacute
+<SunFA_Acute> <O>			: "\323"	Oacute
+<SunFA_Acute> <U>			: "\332"	Uacute
+<SunFA_Acute> <Y>			: "\335"	Yacute
+<SunFA_Acute> <a>			: "\341"	aacute
+<SunFA_Acute> <apostrophe>		: "\264"	acute
+<SunFA_Acute> <e>			: "\351"	eacute
+<SunFA_Acute> <i>			: "\355"	iacute
+<SunFA_Acute> <o>			: "\363"	oacute
+<SunFA_Acute> <space>			: "'"	apostrophe
+<SunFA_Acute> <u>			: "\372"	uacute
+<SunFA_Acute> <y>			: "\375"	yacute
+<SunFA_Circum>  <slash>		: "|"	bar
+<SunFA_Circum> <0>			: "\260"	degree
+<SunFA_Circum> <1>			: "\271"	onesuperior
+<SunFA_Circum> <2>			: "\262"	twosuperior
+<SunFA_Circum> <3>			: "\263"	threesuperior
+<SunFA_Circum> <A>			: "\302"	Acircumflex
+<SunFA_Circum> <E>			: "\312"	Ecircumflex
+<SunFA_Circum> <I>			: "\316"	Icircumflex
+<SunFA_Circum> <O>			: "\324"	Ocircumflex
+<SunFA_Circum> <U>			: "\333"	Ucircumflex
+<SunFA_Circum> <a>			: "\342"	acircumflex
+<SunFA_Circum> <e>			: "\352"	ecircumflex
+<SunFA_Circum> <exclam>			: "\246"	brokenbar
+<SunFA_Circum> <i>			: "\356"	icircumflex
+<SunFA_Circum> <minus>			: "\257"	macron
+<SunFA_Circum> <o>			: "\364"	ocircumflex
+<SunFA_Circum> <period>			: "\267"	periodcentered
+<SunFA_Circum> <space>			: "^"	asciicircum
+<SunFA_Circum> <u>			: "\373"	ucircumflex
+<SunFA_Circum> <underscore>		: "\257"	macron
+<SunFA_Diaeresis> <A>			: "\304"	Adiaeresis
+<SunFA_Diaeresis> <E>			: "\313"	Ediaeresis
+<SunFA_Diaeresis> <I>			: "\317"	Idiaeresis
+<SunFA_Diaeresis> <O>			: "\326"	Odiaeresis
+<SunFA_Diaeresis> <U>			: "\334"	Udiaeresis
+<SunFA_Diaeresis> <a>			: "\344"	adiaeresis
+<SunFA_Diaeresis> <e>			: "\353"	ediaeresis
+<SunFA_Diaeresis> <i>			: "\357"	idiaeresis
+<SunFA_Diaeresis> <o>			: "\366"	odiaeresis
+<SunFA_Diaeresis> <quotedbl>		: "\250"	diaeresis
+<SunFA_Diaeresis> <space>		: "\250"	diaeresis
+<SunFA_Diaeresis> <u>			: "\374"	udiaeresis
+<SunFA_Diaeresis> <y>			: "\377"	ydiaeresis
+<SunFA_Grave> <A>			: "\300"	Agrave
+<SunFA_Grave> <E>			: "\310"	Egrave
+<SunFA_Grave> <I>			: "\314"	Igrave
+<SunFA_Grave> <O>			: "\322"	Ograve
+<SunFA_Grave> <U>			: "\331"	Ugrave
+<SunFA_Grave> <a>			: "\340"	agrave
+<SunFA_Grave> <e>			: "\350"	egrave
+<SunFA_Grave> <i>			: "\354"	igrave
+<SunFA_Grave> <o>			: "\362"	ograve
+<SunFA_Grave> <space>			: "`"	grave
+<SunFA_Grave> <u>			: "\371"	ugrave
+<SunFA_Tilde> <A>			: "\303"	Atilde
+<SunFA_Tilde> <N>			: "\321"	Ntilde
+<SunFA_Tilde> <O>			: "\325"	Otilde
+<SunFA_Tilde> <a>			: "\343"	atilde
+<SunFA_Tilde> <n>			: "\361"	ntilde
+<SunFA_Tilde> <o>			: "\365"	otilde
+<SunFA_Tilde> <space>			: "~"	asciitilde