###############################################################################
# Copyright (c) 2009, Oracle and/or its affiliates. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice (including the next
# paragraph) shall be included in all copies or substantial portions of the
# Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.
#

diff --git a/nls/iso8859-5/Compose.pre b/nls/iso8859-5/Compose.pre
index 01ee440..8dbb2c4 100644
--- a/nls/iso8859-5/Compose.pre
+++ b/nls/iso8859-5/Compose.pre
@@ -3,12 +3,165 @@ XCOMM ISO 8859-5 Compose Sequence
 XCOMM
 XCOMM Sequence Definition
 XCOMM
+XCOMM Copyright (c) 2006, 2009, Oracle and/or its affiliates. All rights reserved.
+XCOMM
+XCOMM Copyright (C) 1994 X Consortium
+XCOMM
+XCOMM Permission is hereby granted, free of charge, to any person obtaining a copy
+XCOMM of this software and associated documentation files (the "Software"), to
+XCOMM deal in the Software without restriction, including without limitation the
+XCOMM rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
+XCOMM sell copies of the Software, and to permit persons to whom the Software is
+XCOMM furnished to do so, subject to the following conditions:
+XCOMM
+XCOMM The above copyright notice and this permission notice shall be included in
+XCOMM all copies or substantial portions of the Software.
+XCOMM
+XCOMM THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+XCOMM IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+XCOMM FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
+XCOMM X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
+XCOMM AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
+XCOMM TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+XCOMM
+XCOMM Except as contained in this notice, the name of the X Consortium shall not
+XCOMM be used in advertising or otherwise to promote the sale, use or other deal-
+XCOMM ings in this Software without prior written authorization from the X Consor-
+XCOMM tium.
+XCOMM
+XCOMM X Window System is a trademark of X Consortium, Inc.
 XCOMM
-XCOMM This file currently has no entries.  It appears that a compose file (even
-XCOMM just an empty one) is required for the appropriate keysyms to work for
-XCOMM this encoding.
 XCOMM
 XCOMM <Multi_key> Means <Compose>
 XCOMM Special Character
+XCOMM
+XCOMM Compose table for the Russian language [gelf]
+
+
+XCOMM
+XCOMM Native English mode
+XCOMM
+
+STATE   "[ English ]"
+Ctrl<T>               : SWITCH_STATE_TO  "[ ÀãááÚØÙ ]"
+Ctrl<space>           : SWITCH_STATE_TO  "[ ÀãááÚØÙ ]"
+<Multi_key>           : SWITCH_STATE_TO  "[ ÀãááÚØÙ ]"
+END_STATE
+
+
+XCOMM
+XCOMM Russian Mode
+XCOMM
+
+
+STATE   "[ ÀãááÚØÙ ]"
+Ctrl<T>        :  SWITCH_STATE_TO "[ English ]"
+Ctrl<space>    :  SWITCH_STATE_TO "[ English ]"
+<Multi_key>    :  SWITCH_STATE_TO "[ English ]"
+XCOMM
+XCOMM
+
+XCOMM Second row
+XCOMM Comment: numerosign is a Cyrillic keysym
+XCOMM Not needed.
+XCOMM<at>            : "\042"	quotedbl
+XCOMM<numbersign>    : "\360"	numerosign
+XCOMM<dollar>        : "\045"	percent
+XCOMM<percent>       : "\072"	colon
+XCOMM<asciicircum>   : "\054"	comma
+XCOMM<ampersand>     : "\056"	period
+XCOMM<asterisk>      : "\073"	semicolon
+XCOMM<numerosign>    : "\360"	numerosign
+
+
+XCOMM Third row
+
+
+<q>             : "\331"	Cyrillic_shorti
+<w>             : "\346"	Cyrillic_tse
+<e>             : "\343"	Cyrillic_u
+<r>             : "\332"	Cyrillic_ka
+<t>             : "\325"	Cyrillic_ie
+<y>             : "\335"	Cyrillic_en
+<u>             : "\323"	Cyrillic_ghe
+<i>             : "\350"	Cyrillic_sha
+<o>             : "\351"	Cyrillic_shcha
+<p>             : "\327"	Cyrillic_ze
+<bracketleft>   : "\345"	Cyrillic_ha
+<bracketright>  : "\352"	Cyrillic_hardsign
+
+
+<Q>             : "\271"	Cyrillic_SHORTI
+<W>             : "\306"	Cyrillic_TSE
+<E>             : "\303"	Cyrillic_U
+<R>             : "\272"	Cyrillic_KA
+<T>             : "\265"	Cyrillic_IE
+<Y>             : "\275"	Cyrillic_EN
+<U>             : "\263"	Cyrillic_GHE
+<I>             : "\310"	Cyrillic_SHA
+<O>             : "\311"	Cyrillic_SHCHA
+<P>             : "\267"	Cyrillic_ZE
+Lock<bracketleft> 	: "\305"	Cyrillic_HA
+Lock<bracketright>	: "\312"	Cyrillic_HARDSIGN
+<braceleft> 	: "\305"	Cyrillic_HA
+<braceright>	: "\312"	Cyrillic_HARDSIGN
+
+
+XCOMM Fourth row
+
+<a>             : "\344"	Cyrillic_ef
+<s>             : "\353"	Cyrillic_yeru
+<d>             : "\322"	Cyrillic_ve
+<f>             : "\320"	Cyrillic_a
+<g>             : "\337"	Cyrillic_pe
+<h>             : "\340"	Cyrillic_er
+<j>             : "\336"	Cyrillic_o
+<k>             : "\333"	Cyrillic_el
+<l>             : "\324"	Cyrillic_de
+<semicolon>     : "\326"	Cyrillic_ghe
+<quoteright>    : "\355"	Cyrillic_e
+
+<A>             : "\304"	Cyrillic_EF
+<S>             : "\313"	Cyrillic_YERU
+<D>             : "\262"	Cyrillic_VE
+<F>             : "\260"	Cyrillic_A
+<G>             : "\277"	Cyrillic_PE
+<H>             : "\300"	Cyrillic_ER
+<J>             : "\276"	Cyrillic_O
+<K>             : "\273"	Cyrillic_EL
+<L>             : "\264"	Cyrillic_DE
+<colon>         : "\266"	Cyrillic_GHE
+<quotedbl>      : "\315"	Cyrillic_E
+
+
+XCOMM Fifth row
+
+<z>             : "\357"	Cyrillic_ya
+<x>             : "\347"	Cyrillic_che
+<c>             : "\341"	Cyrillic_es
+<v>             : "\334"	Cyrillic_em
+<b>             : "\330"	Cyrillic_i
+<n>             : "\342"	Cyrillic_te
+<m>             : "\354"	Cyrillic_softsign
+<comma>         : "\321"	Cyrillic_be
+<period>        : "\356"	Cyrillic_yu
+<slash>         : "\361"	Cyrillic_io
+<backslash>	: "/"		slash
+<bar>		: "?"		question
+
+<Z>             : "\317"	Cyrillic_YA
+<X>             : "\307"	Cyrillic_CHE
+<C>             : "\301"	Cyrillic_ES
+<V>             : "\274"	Cyrillic_EM
+<B>             : "\270"	Cyrillic_I
+<N>             : "\302"	Cyrillic_TE
+<M>             : "\314"	Cyrillic_SOFTSIGN
+<less>          : "\261"	Cyrillic_BE
+<greater>       : "\316"	Cyrillic_YU
+<question>      : "\241"	Cyrillic_IO
+
+
+
+END_STATE
 
 XCOMM End of Sequence Definition