###############################################################################
# Copyright (c) 2009, 2012, Oracle and/or its affiliates. All rights reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice (including the next
# paragraph) shall be included in all copies or substantial portions of the
# Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.
#

diff --git a/nls/iso8859-7/Compose.pre b/nls/iso8859-7/Compose.pre
index c79b277..965cf1a 100644
--- a/nls/iso8859-7/Compose.pre
+++ b/nls/iso8859-7/Compose.pre
@@ -1,4 +1,34 @@
 XCOMM
+XCOMM Copyright (c) 2006, 2009, Oracle and/or its affiliates. All rights reserved.
+XCOMM
+XCOMM
+XCOMM Copyright (C) 1994 X Consortium
+XCOMM
+XCOMM Permission is hereby granted, free of charge, to any person obtaining a copy
+XCOMM of this software and associated documentation files (the "Software"), to
+XCOMM deal in the Software without restriction, including without limitation the
+XCOMM rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
+XCOMM sell copies of the Software, and to permit persons to whom the Software is
+XCOMM furnished to do so, subject to the following conditions:
+XCOMM
+XCOMM The above copyright notice and this permission notice shall be included in
+XCOMM all copies or substantial portions of the Software.
+XCOMM
+XCOMM THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+XCOMM IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+XCOMM FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
+XCOMM X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
+XCOMM AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNEC-
+XCOMM TION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+XCOMM
+XCOMM Except as contained in this notice, the name of the X Consortium shall not
+XCOMM be used in advertising or otherwise to promote the sale, use or other deal-
+XCOMM ings in this Software without prior written authorization from the X Consor-
+XCOMM tium.
+XCOMM
+XCOMM X Window System is a trademark of X Consortium, Inc.
+XCOMM
+XCOMM
 XCOMM ISO 8859-7 (Greek) Compose Sequence
 XCOMM
 XCOMM
@@ -7,216 +37,267 @@ XCOMM Sequence Definition
 XCOMM
 XCOMM <Multi_key> Means <Compose>
 XCOMM Special Character
-<Multi_key> <plus> <plus>		: "#"	numbersign
-<Multi_key> <apostrophe> <space>	: "'"	apostrophe
-<Multi_key> <space> <apostrophe>	: "'"	apostrophe
-<Multi_key> <A> <T>			: "@"	at
-<Multi_key> <parenleft> <parenleft>	: "["	bracketleft
-<Multi_key> <slash> <slash>		: "\\"	backslash
-<Multi_key> <slash> <less>		: "\\"	backslash
-<Multi_key> <less> <slash>		: "\\"	backslash
-<Multi_key> <parenright> <parenright>	: "]"	bracketright
-<Multi_key> <asciicircum> <space>	: "^"	asciicircum
-<Multi_key> <space> <asciicircum>	: "^"	asciicircum
-<Multi_key> <greater> <space>		: "^"	asciicircum
-<Multi_key> <space> <greater>		: "^"	asciicircum
-<Multi_key> <grave> <space>		: "`"	grave
-<Multi_key> <space> <grave>		: "`"	grave
-<Multi_key> <parenleft> <minus>		: "{"	braceleft
-<Multi_key> <minus> <parenleft>		: "{"	braceleft
-<Multi_key> <slash> <asciicircum>	: "|"	bar
-<Multi_key> <asciicircum> <slash>	: "|"	bar
-<Multi_key> <V> <L>			: "|"	bar
-<Multi_key> <L> <V>			: "|"	bar
-<Multi_key> <v> <l>			: "|"	bar
-<Multi_key> <l> <v>			: "|"	bar
-<Multi_key> <parenright> <minus>	: "}"	braceright
-<Multi_key> <minus> <parenright>	: "}"	braceright
-<Multi_key> <asciitilde> <space>	: "~"	asciitilde
-<Multi_key> <space> <asciitilde>	: "~"	asciitilde
-<Multi_key> <minus> <space>		: "~"	asciitilde
-<Multi_key> <space> <minus>		: "~"	asciitilde
-
-<Multi_key> <l> <minus>			: "\243"	sterling
-<Multi_key> <minus> <l>			: "\243"	sterling
-<Multi_key> <L> <minus>			: "\243"	sterling
-<Multi_key> <minus> <L>			: "\243"	sterling
-<Multi_key> <l> <equal>			: "\243"	sterling
-<Multi_key> <equal> <l>			: "\243"	sterling
-<Multi_key> <L> <equal>			: "\243"	sterling
-<Multi_key> <equal> <L>			: "\243"	sterling
-<Multi_key> <s> <o>			: "\247"	section
-<Multi_key> <o> <s>			: "\247"	section
-<Multi_key> <S> <O>			: "\247"	section
-<Multi_key> <O> <S>			: "\247"	section
-<Multi_key> <S> <exclam>		: "\247"	section
-<Multi_key> <exclam> <S>		: "\247"	section
-<Multi_key> <s> <exclam>		: "\247"	section
-<Multi_key> <exclam> <s>		: "\247"	section
-<Multi_key> <S> <0>			: "\247"	section
-<Multi_key> <0> <S>			: "\247"	section
-<Multi_key> <s> <0>			: "\247"	section
-<Multi_key> <0> <s>			: "\247"	section
-<Multi_key> <c> <o>			: "\251"	copyright
-<Multi_key> <o> <c>			: "\251"	copyright
-<Multi_key> <C> <O>			: "\251"	copyright
-<Multi_key> <O> <C>			: "\251"	copyright
-<Multi_key> <c> <O>			: "\251"	copyright
-<Multi_key> <O> <c>			: "\251"	copyright
-<Multi_key> <C> <o>			: "\251"	copyright
-<Multi_key> <o> <C>			: "\251"	copyright
-<Multi_key> <c> <0>			: "\251"	copyright
-<Multi_key> <0> <c>			: "\251"	copyright
-<Multi_key> <C> <0>			: "\251"	copyright
-<Multi_key> <0> <C>			: "\251"	copyright
-<Multi_key> <parenleft> <c>		: "\251"	copyright
-<Multi_key> <less> <less>		: "\253"	guillemotleft
-<Multi_key> <greater> <greater>		: "\273"	guillemotright
-<Multi_key> <0> <asciicircum>		: "\260"	degree
-<Multi_key> <asciicircum> <0>		: "\260"	degree
-<Multi_key> <0> <asterisk>		: "\260"	degree
-<Multi_key> <asterisk> <0>		: "\260"	degree
-<Multi_key> <plus> <minus>		: "\261"	plusminus
-<Multi_key> <minus> <plus>		: "\261"	plusminus
-<Multi_key> <2> <asciicircum>		: "\262"	twosuperior
-<Multi_key> <asciicircum> <2>		: "\262"	twosuperior
-<Multi_key> <S> <2>			: "\262"	twosuperior
-<Multi_key> <2> <S>			: "\262"	twosuperior
-<Multi_key> <s> <2>			: "\262"	twosuperior
-<Multi_key> <2> <s>			: "\262"	twosuperior
-<Multi_key> <3> <asciicircum>		: "\263"	threesuperior
-<Multi_key> <asciicircum> <3>		: "\263"	threesuperior
-<Multi_key> <S> <3>			: "\263"	threesuperior
-<Multi_key> <3> <S>			: "\263"	threesuperior
-<Multi_key> <s> <3>			: "\263"	threesuperior
-<Multi_key> <3> <s>			: "\263"	threesuperior
-<Multi_key> <period> <asciicircum>	: "\267"	periodcentered
-<Multi_key> <asciicircum> <period>	: "\267"	periodcentered
-<Multi_key> <period> <period>		: "\267"	periodcentered
-<Multi_key> <1> <2>			: "\275"	onehalf
-<Multi_key> <space> <space>		: "\240"	nobreakspace
-<Multi_key> <bar> <bar>			: "\246"	brokenbar
-<Multi_key> <exclam> <asciicircum>	: "\246"	brokenbar
-<Multi_key> <asciicircum> <exclam>	: "\246"	brokenbar
-<Multi_key> <V> <B>			: "\246"	brokenbar
-<Multi_key> <B> <V>			: "\246"	brokenbar
-<Multi_key> <v> <b>			: "\246"	brokenbar
-<Multi_key> <b> <v>			: "\246"	brokenbar
-<Multi_key> <minus> <comma>		: "\254"	notsign
-<Multi_key> <comma> <minus>		: "\254"	notsign
-<Multi_key> <minus> <minus>		: "\255"	hyphen
-XCOMM should be Greek tonos but not defined in X11
-<Multi_key> <apostrophe> <apostrophe>	: "\264"	acute
-XCOMM should be Greek dialytika but not defined in X11
-<Multi_key> <quotedbl> <quotedbl>	: "\250"	diaeresis
-XCOMM special characters that don't exist in Latin-1
-<Multi_key> <less> <apostrophe>		: "\241"	leftsinglequotemark
-<Multi_key> <apostrophe> <less>		: "\241"	leftsinglequotemark
-<Multi_key> <greater> <apostrophe>	: "\242"	rightsinglequotemark
-<Multi_key> <apostrophe> <greater>	: "\242"	rightsinglequotemark
-<Multi_key> <asciitilde> <asciitilde>	: "\257"	Greek_horizbar
-
-XCOMM Accented Alphabet
-<Multi_key> <Greek_ALPHA> <apostrophe>	: "\266" Greek_ALPHAaccent
-<Multi_key> <apostrophe> <Greek_ALPHA>	: "\266" Greek_ALPHAaccent
-<Multi_key> <Greek_EPSILON> <apostrophe>: "\270" Greek_EPSILONaccent
-<Multi_key> <apostrophe> <Greek_EPSILON>: "\270" Greek_EPSILONaccent
-<Multi_key> <Greek_ETA> <apostrophe>	: "\271" Greek_ETAaccent
-<Multi_key> <apostrophe> <Greek_ETA>	: "\271" Greek_ETAaccent
-<Multi_key> <Greek_IOTA> <apostrophe>	: "\272" Greek_IOTAaccent
-<Multi_key> <apostrophe> <Greek_IOTA>	: "\272" Greek_IOTAaccent
-<Multi_key> <Greek_OMICRON> <apostrophe>: "\274" Greek_OMICRONaccent
-<Multi_key> <apostrophe> <Greek_OMICRON>: "\274" Greek_OMICRONaccent
-<Multi_key> <Greek_UPSILON> <apostrophe>: "\276" Greek_UPSILONaccent
-<Multi_key> <apostrophe> <Greek_UPSILON>: "\276" Greek_UPSILONaccent
-<Multi_key> <Greek_OMEGA> <apostrophe>	: "\277" Greek_OMEGAaccent
-<Multi_key> <apostrophe> <Greek_OMEGA>	: "\277" Greek_OMEGAaccent
-<Multi_key> <Greek_IOTA> <quotedbl>	: "\332" Greek_IOTAdieresis
-<Multi_key> <quotedbl> <Greek_IOTA>	: "\332" Greek_IOTAdieresis
-<Multi_key> <Greek_UPSILON> <quotedbl>	: "\333" Greek_UPSILONdieresis
-<Multi_key> <quotedbl> <Greek_UPSILON>	: "\333" Greek_UPSILONdieresis
-
-<Multi_key> <Greek_alpha> <apostrophe>	: "\334" Greek_alphaaccent
-<Multi_key> <apostrophe> <Greek_alpha>	: "\334" Greek_alphaaccent
-<Multi_key> <Greek_epsilon> <apostrophe>: "\335" Greek_epsilonaccent
-<Multi_key> <apostrophe> <Greek_epsilon>: "\335" Greek_epsilonaccent
-<Multi_key> <Greek_eta> <apostrophe>	: "\336" Greek_etaaccent
-<Multi_key> <apostrophe> <Greek_eta>	: "\336" Greek_etaaccent
-<Multi_key> <Greek_iota> <apostrophe>	: "\337" Greek_iotaaccent
-<Multi_key> <apostrophe> <Greek_iota>	: "\337" Greek_iotaaccent
-<Multi_key> <Greek_omicron> <apostrophe>: "\374" Greek_omicronaccent
-<Multi_key> <apostrophe> <Greek_omicron>: "\374" Greek_omicronaccent
-<Multi_key> <Greek_upsilon> <apostrophe>: "\375" Greek_upsilonaccent
-<Multi_key> <apostrophe> <Greek_upsilon>: "\375" Greek_upsilonaccent
-<Multi_key> <Greek_omega> <apostrophe>	: "\376" Greek_omegaaccent
-<Multi_key> <apostrophe> <Greek_omega>	: "\376" Greek_omegaaccent
-<Multi_key> <Greek_iota> <quotedbl>	: "\372" Greek_iotadieresis
-<Multi_key> <quotedbl> <Greek_iota>	: "\372" Greek_iotadieresis
-<Multi_key> <Greek_upsilon> <quotedbl>	: "\373" Greek_upsilondieresis
-<Multi_key> <quotedbl> <Greek_upsilon>	: "\373" Greek_upsilondieresis
-
-<Multi_key> <apostrophe> <quotedbl> <Greek_iota>	: "\300" Greek_iotaaccentdieresis
-<Multi_key> <quotedbl> <apostrophe> <Greek_iota>	: "\300" Greek_iotaaccentdieresis
-<Multi_key> <apostrophe> <quotedbl> <Greek_upsilon>	: "\340" Greek_upsilonaccentdieresis
-<Multi_key> <quotedbl> <apostrophe> <Greek_upsilon>	: "\340" Greek_upsilonaccentdieresis
-<Multi_key> <apostrophe> <quotedbl> <space>		: "\265" Greek_accentdieresis
-<Multi_key> <quotedbl> <apostrophe> <space>		: "\265" Greek_accentdieresis
-
-XCOMM
-XCOMM
-XCOMM dead key accent keysyms
-XCOMM Special Character
-<dead_circumflex> <slash>		: "|"	bar
-<dead_grave> <space>			: "`"	grave
-<dead_diaeresis> <space>		: "\250"	diaeresis
-<dead_circumflex> <space>		: "^"	asciicircum
-<dead_tilde> <space>			: "~"	asciitilde
-<dead_doubleacute> <space>		: "\""	quotedbl
-<dead_abovering> <space>		: "\260"	degree
-<dead_abovering> <dead_abovering>	: "\260"	degree
-<dead_circumflex> <0>			: "\260"	degree
-<dead_circumflex> <2>			: "\262"	twosuperior
-<dead_circumflex> <3>			: "\263"	threesuperior
-<dead_circumflex> <period>		: "\267"	periodcentered
-<dead_circumflex> <exclam>		: "\246"	brokenbar
-<dead_cedilla> <minus>			: "\254"	notsign
-<dead_acute> <apostrophe>		: "\264"	acute
-<dead_diaeresis> <quotedbl>		: "\250"	diaeresis
-
-XCOMM Accented Alphabet (plus some more symbols)
-<dead_acute> <Greek_alpha>		: "\334"	Greek_alphaaccent
-<dead_acute> <Greek_epsilon>		: "\335"	Greek_epsilonaccent
-<dead_acute> <Greek_eta>		: "\336"	Greek_etaaccent
-<dead_acute> <Greek_iota>		: "\337"	Greek_iotaaccent
-<dead_acute> <Greek_omicron>		: "\374"	Greek_omicronaccent
-<dead_acute> <Greek_upsilon>		: "\375"	Greek_upsilonaccent
-<dead_acute> <Greek_omega>		: "\376"	Greek_omegaaccent
-<dead_acute> <Greek_ALPHA>		: "\266"	Greek_ALPHAaccent
-<dead_acute> <Greek_EPSILON>		: "\270"	Greek_EPSILONaccent
-<dead_acute> <Greek_ETA>		: "\271"	Greek_ETAaccent
-<dead_acute> <Greek_IOTA>		: "\272"	Greek_IOTAaccent
-<dead_acute> <Greek_OMICRON>		: "\274"	Greek_OMICRONaccent
-<dead_acute> <Greek_UPSILON>		: "\276"	Greek_UPSILONaccent
-<dead_acute> <Greek_OMEGA>		: "\277"	Greek_OMEGAaccent
-<dead_acute> <space>			: "\264"	acute
-<dead_acute> <dead_acute>		: "\264"	acute
-<dead_acute> <period>			: "\267"	periodcentered
-<dead_acute> <less>			: "\253"	guillemotleft
-<dead_acute> <greater>			: "\273"	guillemotright
-
-<dead_diaeresis> <Greek_iota>		: "\372"	Greek_iotadieresis
-<dead_diaeresis> <Greek_upsilon>	: "\373"	Greek_upsilondieresis
-<dead_diaeresis> <Greek_IOTA>		: "\332"	Greek_IOTAdieresis
-<dead_diaeresis> <Greek_UPSILON>	: "\333"	Greek_UPSILONdieresis
-<dead_diaeresis> <dead_diaeresis>	: "\250"	diaeresis
-<dead_diaeresis> <period>		: "\267"	periodcentered
-<dead_diaeresis> <less>			: "\253"	guillemotleft
-<dead_diaeresis> <greater>		: "\273"	guillemotright
-
-<dead_acute> <dead_diaeresis> <Greek_iota>	: "\300"	Greek_iotaaccentdieresis
-<dead_acute> <dead_diaeresis> <Greek_upsilon>	: "\340"	Greek_upsilonaccentdieresis
-<dead_acute> <dead_diaeresis> <space>		: "\265"	Greek_accentdieresis
-
-<dead_diaeresis> <dead_acute> <Greek_iota>	: "\300"	Greek_iotaaccentdieresis
-<dead_diaeresis> <dead_acute> <Greek_upsilon>	: "\340"	Greek_upsilonaccentdieresis
-<dead_diaeresis> <dead_acute> <space>		: "\265"	Greek_accentdieresis
+
+XCOMM
+XCOMM
+XCOMM Compose table for the Greek language [timf]
+XCOMM
+
+
+XCOMM
+XCOMM Native English mode
+XCOMM
+
+STATE   "[ English ]"
+Ctrl<space>            	: SWITCH_STATE_TO  "[ EëëçíéêÜ ]"
+<Multi_key>		: SWITCH_STATE_TO  "[ EëëçíéêÜ ]"
+<dead_acute>		: "\073"		semicolon
+<dead_diaeresis>	: "\072"	colon
+
+XCOMM Added for support for new glyphs : drachma, greek question mark
+XCOMM and greek ypogegrammeni - v.lee,g11n(27/9/2001)
+<drachma>	:	"\245"	drachma
+<erotimatiko>	:	"\256"	Greek_questionmark
+<ypogegrammeni> :	"\252"	Greek_ypogegrammeni
+XCOMM Compose sequences to bring up the glyphs
+Ctrl<T> <D>		:	"\245"
+Ctrl<T> <Q> 		:	"\256"
+Ctrl<T> <Y> 		:	"\252"
+END_STATE
+
+
+XCOMM
+XCOMM Greek mode
+XCOMM
+
+
+STATE   "[ EëëçíéêÜ ]"
+Ctrl<space>    :  SWITCH_STATE_TO "[ English ]"
+<Multi_key>    :  SWITCH_STATE_TO "[ English ]"
+
+XCOMM Added for support for new glyphs : drachma, greek question mark
+XCOMM and greek ypogegrammeni - v.lee,g11n(27/9/2001)
+<drachma>	:	"\245"	drachma
+<erotimatiko>	:	"\256"	Greek_questionmark
+<ypogegrammeni> :	"\252"	Greek_ypogegrammeni
+XCOMM Compose sequences to bring up the glyphs
+Ctrl<T> <D> 		:	"\245"
+Ctrl<T> <Q> 		:	"\256"
+Ctrl<T> <Y> 		:	"\252"
+
+
+XCOMM Second row
+
+<at>		: "\100"	at
+<numbersign>	: "\043"	numbersign
+<dollar>	: "\044"	dollar
+<percent>	: "\045"	percent
+<asciicircum>	: "\136"	asciicircum
+<ampersand>	: "\046"	ampersand
+<asterisk>	: "\052"	asterisk
+
+
+XCOMM Third row
+
+
+<q>             : "\073"	semicolon
+<w>             : "\362"	Greek_sigma
+<e>             : "\345"	Greek_epsilon
+<r>             : "\361"	Greek_rho
+<t>             : "\364"	Greek_tau
+<y>             : "\365"	Greek_upsilon
+<u>             : "\350"	Greek_theta
+<i>             : "\351"	Greek_iota
+<o>             : "\357"	Greek_omicron
+<p>             : "\360"	Greek_pi
+
+<Greek_sigma>             	: "\362"	Greek_sigma
+<Greek_epsilon>             	: "\345"	Greek_epsilon
+<Greek_rho>             	: "\361"	Greek_rho
+<Greek_tau>             	: "\364"	Greek_tau
+<Greek_upsilon>             	: "\365"	Greek_upsilon
+<Greek_theta>             	: "\350"	Greek_theta
+<Greek_iota>             	: "\351"	Greek_iota
+<Greek_omicron>             	: "\357"	Greek_omicron
+<Greek_pi>             		: "\360"	Greek_pi
+
+
+
+<Q>            	: "\072"	colon
+<W>            	: "\323"	Greek_SIGMA
+<E>             : "\305"	Greek_EPSILON
+<R>             : "\321"	Greek_RHO
+<T>             : "\324"	Greek_TAU
+<Y>             : "\325"	Greek_UPSILON
+<U>             : "\310"	Greek_THETA
+<I>             : "\311"	Greek_IOTA
+<O>             : "\317"	Greek_OMICRON
+<P>             : "\320"	Greek_PI
+
+<Greek_SIGMA>            	: "\323"	Greek_SIGMA
+<Greek_EPSILON>             	: "\305"	Greek_EPSILON
+<Greek_RHO>             	: "\321"	Greek_RHO
+<Greek_TAU>             	: "\324"	Greek_TAU
+<Greek_UPSILON>             	: "\325"	Greek_UPSILON
+<Greek_THETA>             	: "\310"	Greek_THETA
+<Greek_IOTA>             	: "\311"	Greek_IOTA
+<Greek_OMICRON>             	: "\317"	Greek_OMICRON
+<Greek_PI>             		: "\320"	Greek_PI
+
+
+
+XCOMM Fourth row
+
+<a>             : "\341"	Greek_alpha
+<s>             : "\363"	Greek_finalsmallsigma
+<d>             : "\344"	Greek_delta
+<f>             : "\366"	Greek_phi
+<g>             : "\343"	Greek_gamma
+<h>             : "\347"	Greek_eta
+<j>             : "\356"	Greek_xi
+<k>             : "\352"	Greek_kappa
+<l>             : "\353"	Greek_lamda
+
+<Greek_alpha>             	: "\341"	Greek_alpha
+<Greek_finalsmallsigma>       	: "\363"	Greek_finalsmallsigma
+<Greek_delta>             	: "\344"	Greek_delta
+<Greek_phi>             	: "\366"	Greek_phi
+<Greek_gamma>             	: "\343"	Greek_gamma
+<Greek_eta>             	: "\347"	Greek_eta
+<Greek_xi>             		: "\356"	Greek_xi
+<Greek_kappa>             	: "\352"	Greek_kappa
+<Greek_lamda>             	: "\353"	Greek_lamda
+
+<A>             : "\301"	Greek_ALPHA
+<S>             : "\323"	Greek_SIGMA
+<D>             : "\304"	Greek_DELTA
+<F>             : "\326"	Greek_PHI
+<G>             : "\303"	Greek_GAMMA
+<H>             : "\307"	Greek_ETA
+<J>             : "\316"	Greek_XI
+<K>             : "\312"	Greek_KAPPA
+<L>             : "\313"	Greek_LAMDA
+
+<Greek_ALPHA>             	: "\301"	Greek_ALPHA
+<Greek_SIGMA>             	: "\323"	Greek_SIGMA
+<Greek_DELTA>             	: "\304"	Greek_DELTA
+<Greek_PHI>             	: "\326"	Greek_PHI
+<Greek_GAMMA>             	: "\303"	Greek_GAMMA
+<Greek_ETA>             	: "\307"	Greek_ETA
+<Greek_XI>             		: "\316"	Greek_XI
+<Greek_KAPPA>             	: "\312"	Greek_KAPPA
+<Greek_LAMDA>             	: "\313"	Greek_LAMDA
+
+
+XCOMM Fifth row
+
+<z>             : "\346"	Greek_zeta
+<x>             : "\367"	Greek_chi
+<c>             : "\370"	Greek_psi
+<v>             : "\371"	Greek_omega
+<b>             : "\342"	Greek_beta
+<n>             : "\355"	Greek_nu
+<m>             : "\354"	Greek_mu
+
+<Greek_zeta>             	: "\230"	Greek_zeta
+<Greek_chi>             	: "\367"	Greek_chi
+<Greek_psi>             	: "\370"	Greek_psi
+<Greek_omega>             	: "\371"	Greek_omega
+<Greek_beta>             	: "\342"	Greek_beta
+<Greek_nu>             		: "\355"	Greek_nu
+<Greek_mu>             		: "\354"	Greek_mu
+
+
+<Z>             : "\306"	Greek_ZETA
+<X>             : "\327"	Greek_CHI
+<C>             : "\330"	Greek_PSI
+<V>             : "\331"	Greek_OMEGA
+<B>             : "\302"	Greek_BETA
+<N>             : "\315"	Greek_NU
+<M>             : "\314"	Greek_MU
+<less>          : "\74"		less
+<greater>       : "\76"		greater
+<question>      : "\77"		question
+<Greek_ZETA>             	: "\306"	Greek_ZETA
+<Greek_CHI>             	: "\327"	Greek_CHI
+<Greek_PSI>             	: "\330"	Greek_PSI
+<Greek_OMEGA>             	: "\331"	Greek_OMEGA
+<Greek_BETA>             	: "\302"	Greek_BETA
+<Greek_NU>             		: "\315"	Greek_NU
+<Greek_MU>             		: "\314"	Greek_MU
+<periodcentered>      		: "\267"	periodcentered
+
+
+@StartDeadKeyMap <acute>
+
+XCOMM- small chars
+<dead_acute> <a>			:"\334"		Greek_alphaaccent
+<dead_acute> <e>			:"\335"		Greek_epsilonaccent
+<dead_acute> <h>			:"\336"		Greek_etaaccent
+<dead_acute> <i>			:"\337"		Greek_iotaaccent
+<dead_acute> <o>			:"\374"		Greek_omicronaccent
+<dead_acute> <y>			:"\375"		Greek_upsilonaccent
+<dead_acute> <v>			:"\376"		Greek_omegaaccent
+
+XCOMM- caps
+<dead_acute> <A>			:"\266"		Greek_ALPHAaccent
+<dead_acute> <E>			:"\270"		Greek_EPSILONaccent
+<dead_acute> <H>			:"\271"		Greek_ETAaccent
+<dead_acute> <I>			:"\272"		Greek_IOTAaccent
+<dead_acute> <O>			:"\274"		Greek_OMICRONaccent
+<dead_acute> <Y>			:"\276"		Greek_UPSILONaccent
+<dead_acute> <V>			:"\277"		Greek_OMEGAaccent
+
+XCOMM numeric
+
+<dead_acute> <0>				:"\261"		plusminus
+<dead_acute> <1>				:"\247"		section
+<dead_acute> <2>				:"\262"		twosuperior
+<dead_acute> <3>				:"\263"		threesuperior
+<dead_acute> <4>				:"\244"
+<dead_acute> <5>				:"\246"		brokenbar
+<dead_acute> <6>				:"\251"		copyright
+<dead_acute> <7>				:"\254"		notsign
+<dead_acute> <8>				:"\255"		hyphen
+<dead_acute> <9>				:"\260"		degree
+<dead_acute> <hyphen>				:"\275"		onehalf
+<dead_acute> <equal>				:"\245"
+<dead_acute> <backslash>			:"\243"		sterling
+<dead_acute> <braceleft>			:"\241"		leftsinglequotemark
+<dead_acute> <braceright>			:"\242"		rightsinglequotemark
+<dead_acute> <bracketleft>			:"\253"		guillemotleft
+<dead_acute> <bracketright>			:"\273"		guillemotright
+
+XCOMM- pseudo dead key to simulate double dead key support
+<diaeresis>	=<SunSMCCPseudoDeadKey>
+
+@EndDeadKeyMap
+
+@StartDeadKeyMap <diaeresis>
+
+<dead_diaeresis><dead_acute><space>		:"\265"		Greek_accentdieresis
+<dead_acute><dead_diaeresis><space>		:"\265"		Greek_accentdieresis
+
+XCOMM- small chars
+<dead_diaeresis> <i>			:"\372"		Greek_iotadieresis
+<dead_diaeresis> <y>			:"\373"		Greek_upsilondieresis
+
+XCOMM- caps
+<dead_diaeresis> <I>				:"\332"		Greek_IOTAdiaeresis
+<dead_diaeresis> <Y>				:"\333"		Greek_UPSILONdieresis
+
+
+
+<dead_acute><dead_diaeresis><y>       :"\340"         Greek_upsilonaccentdieresis
+<dead_diaeresis><dead_acute><y>       :"\340"         Greek_upsilonaccentdieresis
+
+<dead_acute> <dead_diaeresis> <i>       :"\300"         Greek_iotaaccentdieresis
+<dead_diaeresis> <dead_acute> <i>      :"\300"         Greek_iotaaccentdieresis
+
+XCOMM- pseudo dead key to simulate double dead key support
+<acute>		=<SunSMCCPseudoDeadKey>
+
+@EndDeadKeyMap
+
+
+END_STATE